<?php

// =============================================================================
// BannerRotation.php
//
// Monthly Banner MOD for Simple Machines Forum
// =============================================================================
//
// Monthly Banners and Holidays by:	 	The Wizard (http://www.wizardsplanet.com)
// Version Number:						V 3.7
// Copyright 2013 by:					The Wizard
//
// License:
// This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License.
// You may not use this SMF modification except in compliance with
// the License. You may obtain a copy of the License at
// http://creativecommons.org/licenses/by-nc-nd/3.0/deed.en_US
//
// You are allowed to modify, or add to BannerRotation.php as long as
// you agree to post your changes on Simple Machines, and allow anyone
// to use those changes. - The Wizard
//
// Artwork by Velasca: Copygight - www.wizardsplanet.com/index.php?topic=46.0
//
// Wizard Image: Copyright - www.wizardsplanet.com/index.php?topic=47.0
//
// ==============================================================================

if (!defined('SMF'))
die('Hacking attempt...');

Function BannerRotation()
{
	floating_holidays();
	core_banner_rotation();
}


Function floating_holidays()
{
	global $easter, $thanksgiving;

	// Easter Sunday
	$easter = date('m d', easter_date()) ;

	// Thanksgiving
	//This gets today's date 
	$date =time () ;

	//This makes the current year a variable 
	$year = date('Y', $date) ;

	//Here we generate the first day of November
	$first_day = mktime(0,0,0,11, 1, $year) ;

	//We determine what day of the week the first falls on
	$day_of_week = date('D', $first_day) ;

	//Based upon this, we add the appropriate number of days to get to the forth Thursday of the month

	switch($day_of_week){ 
	case "Sun": $add = 25; break;
	case "Mon": $add = 24; break; 
	case "Tue": $add = 23; break; 
	case "Wed": $add = 22; break; 
	case "Thu": $add = 21; break; 
	case "Fri": $add = 27; break; 
	case "Sat": $add = 26; break; 
	}

	$thanksgiving = '11 ' . 1 + $add;
}


Function core_banner_rotation()
{
	global $settings, $context, $modSettings, $easter, $thanksgiving;

	// Finds out what month, and day it is for the system test
	$date_test = date('m d');

	// Start Holidays
	// Note: $date_test => array('holiday_settings_today', 'Today'),
	// is a system test, and must come first in the array or it will take over your holiday banner
	$holidays = array(
		$date_test => array('holiday_settings_today', 'Today'),
		'01 01' => array('holiday_settings_new_years', 'New_Years'),
		'02 14' => array('holiday_settings_valentines', 'Valentines'),
		'03 17' => array('holiday_settings_st_patricks','St_Patricks'),
		$easter => array('holiday_settings_easter', 'Easter'),
		'04 01' => array('holiday_settings_april_fools', 'April_Fools'),
		'07 04' => array('holiday_settings_july_4th', 'Independence_Day'),
		'10 31' => array('holiday_settings_halloween', 'Halloween'),
		$thanksgiving => array('holiday_settings_thanksgiving', 'Thanksgiving'),
		'12 25' => array('holiday_settings_christmas', 'Christmas'),
	);

	// Find out what day and month it is.
	// If the user has set the local time in his profile the holidays banners will show up in local time
	// If the user has not set the local time the holiday banners will show up using server time
	$date = date('m d', strtotime($context['current_time']));

	if (isset($holidays[$date]) && !empty($modSettings[$holidays[$date][0]]))
	{
		// Show Holiday Banner
		$holiday_dir_path = $settings['default_theme_dir'] . '/images/banners/holiday_images/big/';
		$holiday_url_path = $settings['default_theme_url'] . '/images/banners/holiday_images/big/';

		// Figure out what Holiday
		$holiday_date = $holidays[$date][1];

		// Read dir of Holiday Monthly Banner Images
		$handle = opendir($holiday_dir_path);
		while($entry = readdir($handle))
		{
			if($entry != '.' && $entry != '..')
			{
			$holiday_images[] = $entry;
			}
		}
		closedir($handle);

		$holidays_extensions = array(
			$holiday_date . '.jpeg',
			$holiday_date . '.jpg',
			$holiday_date . '.gif',
			$holiday_date . '.png'
		);

		foreach ($holiday_images as $image)
		{
			if (in_array($image, $holidays_extensions))
			{
				//Display Holiday Banner
				echo '<div id="banner_size"><br /><img border="0" src="', $holiday_url_path . $image . '" alt="" class="banner_center banner_border banner_size" /><br /></div>';
			}
		}
	}
	else
	{
		// Show Monthly Banner
		$uploaddir = $settings['default_theme_dir'] . '/images/banners/banner_images/big/';
		$url_path = $settings['default_theme_url'] . '/images/banners/banner_images/big/';

		// Read dir Monthly Banner Images
		$handle = opendir($uploaddir);
		while($entry = readdir($handle))
		{
			if($entry != '.' && $entry != '..')
			{
			$Images[] = $entry;
			}
		}
		closedir($handle);

		// Find out what month it is.
		// If the user has set the local time in his profile the monthly banners will show up in local time
		// If the user has not set the local time the monthly banners will show up using server time
		$month = date('F', strtotime($context['current_time']));

		$possible_items = array(
			$month . '.jpeg',
			$month . '.jpg',
			$month . '.gif',
			$month . '.png'
		);

		foreach ($Images as $image)
		{
			if (in_array($image, $possible_items))
			{
				//Display Banner
				echo '<div id="banner_size"><br /><img border="0" src="', $url_path . $image . '" alt="" class="banner_center banner_border banner_size" /><br /></div>';
			}
		}
	}
}

// End of Script

