<?php

// =============================================================================
// Banners.php
//
// Monthly Banner MOD for Simple Machines Forum
// =============================================================================
//
// Monthly Banners and Holidays by:	 	The Wizard (http://www.wizardsplanet.com)
// Version Number:						V 3.7
// Copyright 2013 by:					The Wizard
//
// License:
// This work is licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License.
// You may not use this SMF modification except in compliance with
// the License. You may obtain a copy of the License at
// http://creativecommons.org/licenses/by-nc-nd/3.0/deed.en_US
//
// Artwork by Velasca: Copygight - www.wizardsplanet.com/index.php?topic=46.0 
//
// Wizard Image: Copyright - www.wizardsplanet.com/index.php?topic=47.0
//
// ==============================================================================

if (!defined('SMF'))
	die('Hacking attempt...');

Function BannerAdd()
{
	global $context, $txt, $settings;

	loadTemplate('Banners');
	$context['page_title'] = $txt['banner_add'];
	$context['sub_template'] = 'addBanners';
	basic_settings();
	banner_settings();
	show_banners();
	upload_banners();
}

Function BannerRemove()
{
	global $context, $txt, $settings;

	loadTemplate('Banners');
	$context['page_title'] = $txt['banner_remove'];
	$context['sub_template'] = 'removeBanners';
	basic_settings();
	banner_settings();
	show_banners();
	remove_banners();
}

Function HolidayAdd()
{
	global $context, $txt, $settings;

	loadTemplate('Banners');
	$context['page_title'] = $txt['holiday_add'];
	$context['sub_template'] = 'addHolidayBanners';
	basic_settings();
	holiday_banner_settings();
	show_banners();
	upload_holiday_banners();
}

Function HolidayRemove()
{
	global $context, $txt, $settings;
	
	loadTemplate('Banners');
	$context['page_title'] = $txt['holiday_remove'];
	$context['sub_template'] = 'removeHolidayBanners';
	basic_settings();
	holiday_banner_settings();
	show_banners();
	remove_holiday_banners();
}

Function basic_settings()
{
	global $max_width, $max_height, $newwidth, $newheight, $max_size, $allowed_files;

	$max_width		= '1024';
	$max_height		= '200';
	$newwidth		= 400;
	$newheight		= 78;
	$max_size		= '500000';
	$allowed_files	= array(
		'jpeg',
		'jpg',
		'png',
		'gif'
	);
}

Function holiday_banner_settings()
{
	global $settings, $thumbnail_dir, $uploaddir, $months;

	$thumbnail_dir = $settings['default_theme_dir'] . '/images/banners/holiday_images/small/';
	$uploaddir = $settings['default_theme_dir'] . '/images/banners/holiday_images/big/';

	$months = array(
		'new_years'			=> 1,
		'valentines'		=> 2,
		'st_patricks'		=> 3,
		'easter'			=> 4,
		'april_fools'		=> 5,
		'independence_day'	=> 6,
		'halloween'			=> 7,
		'thanksgiving'		=> 8,
		'christmas'			=> 9,
		'today'				=> 10,
	);
}

Function banner_settings()
{
	global $settings, $txt, $thumbnail_dir, $uploaddir, $months, $month;

	$thumbnail_dir = $settings['default_theme_dir'] . '/images/banners/banner_images/small/';
	$uploaddir = $settings['default_theme_dir'] . '/images/banners/banner_images/big/';

	$month = array_map('ucfirst', $txt['months']);
	$months = array_flip(array_map('lcfirst', $month));
}


// When show_banners function is call it will show all the banners stored in the big dir by showing a thumbnail version.


Function show_banners()
{
	global $context, $txt, $settings, $allowed_files, $thumbnail_dir, $months;

	$handle = opendir($thumbnail_dir);
	while($entry = readdir($handle))
	{
		if($entry != '.' && $entry != '..')
		{
			$Images[] = $entry;
		}
	}
	closedir($handle);

	if (!empty($handle) && is_object($handle))
	$context['banner_file_check_error'] = $txt['banner_file_check_error'];

	$months_with_extension = array();

	foreach ($Images as $image_name)
	{
		$month_pieces = explode('.', strtolower($image_name));

		if (count($month_pieces) == 2 && isset($months[$month_pieces[0]]) && in_array($month_pieces[1], $allowed_files))
		$months_with_extension[$months[$month_pieces[0]]] = $image_name;
	}

	ksort($months_with_extension);

	// Output only January to June Banners
	$output_one = array_intersect_key($months_with_extension, array(
		'1' => 1,
		'2' => 1,
		'3' => 1,
		'4' => 1,
		'5' => 1,
		'6' => 1
	));

	// Send January to June Banner data to template
	$context['banner_show_images_one'] = $output_one;

	// Output only July to December Banners
	$output_two = array_intersect_key($months_with_extension, array(
		'7' =>	1,
		'8' =>	1,
		'9' =>	1,
		'10' =>	1,
		'11' =>	1,
		'12' =>	1
	));

	// Send July to December Banner data to template
	$context['banner_show_images_two'] = $output_two;
}


// When upload_banners function is call it will upload the banner in the big dir.


Function upload_banners()
{
	global $context, $txt, $uploaddir, $max_width, $max_height, $max_size, $allowed_files;

	$errors = array();

	if (isset($_POST['submit']))
	{
		checkSession('post');
		$image = $_FILES['image']['name'];
		$temp_name = $_FILES['image']['tmp_name'];

		if(empty($image) or empty($temp_name) or empty($_FILES))
		fatal_lang_error('banner_file_check_error', false);

		$parts		= explode(".", $image);
		$extension	= end($parts);
		$extension	= strtolower($extension);
		$name		= str_replace("." . $extension, "", $image);

		// Uploaded the image
		if (move_uploaded_file($temp_name, $uploaddir . $image))
		{
			// 1. Check to see if image size is 1024 by 200
			if (list($width, $height) = getimagesize($uploaddir . $image))
				{
				if ($width != $max_width && $height != $max_height)
					$errors[] = $txt['banner_error_1'];
				}
		else
		// 2. Check to see if the uploaded file is a image or not
		$errors[] = $txt['banner_error_2'];

		// 3. Check to see if file size is under the set max limit
		if ($_FILES['image']['size'] > $max_size)
			$errors[] = $txt['banner_error_3'];

		// 4. Check to see if the monthly file name is spelled correct
		$month = array(
			'January',
			'February',
			'March',
			'April',
			'May',
			'June',
			'July',
			'August',
			'September',
			'October',
			'November',
			'December'
		);

		if (!in_array($name, $month))
			$errors[] = $txt['banner_error_4'];

		// 5. Check to see if the allowed image extension is correct
		if (!in_array($extension, $allowed_files))
			$errors[] = $txt['banner_error_5'];
		}
		else
		// 6. If the system is unable to upload image for any reason print Unable to upload file
		$errors[] = $txt['banner_error_6'];

		//Display errors and print Copy unsuccessful message, and remove image.
		if (!empty($errors))
		{
			$context['banner_errors'] = $errors;
			unlink($uploaddir . $image);
			$context['banner_error_general'] = $txt['banner_error_general'];
		}
		else
		{
			// Start of thumbnail creation
			$call = 'create'. ucfirst($extension);
			$call();

			//If no errors registered, print the success message
			redirectexit('action=admin;area=monthlybanners;sa=banner_add');
		}
	}
}


// When remove_banners function is call it will remove the selected banner in the big dir and the small dir.


Function remove_banners()
{
	global $context, $txt, $settings, $uploaddir, $thumbnail_dir;

	// Remove chosen banner from big and small files
	if(isset($_GET['b']))
	{
		$inputted_banner = $_GET['b'];

		if(empty($_GET['b']))
		{
		fatal_lang_error('banner_file_check_error', false);
		}
	}

	if (!empty($inputted_banner))
	{
		unlink($uploaddir . $inputted_banner);
		unlink($thumbnail_dir . $inputted_banner);

		// Refresh the Page and Clear the Post Data
		redirectexit('action=admin;area=monthlybanners;sa=banner_remove');
	}
}


// When upload_holiday_banners function is call it will upload the holiday banner in the big dir.


Function upload_holiday_banners()
{
	global $context, $txt, $uploaddir, $max_width, $max_height, $max_size, $allowed_files;

	$errors = array();

	if (isset($_POST['submit']))
	{
		checkSession('post');
		$image = $_FILES['image']['name'];
		$temp_name = $_FILES['image']['tmp_name'];

		if(empty($image) or empty($temp_name) or empty($_FILES))
		fatal_lang_error('banner_file_check_error', false);

		$parts		= explode(".", $image);
		$extension	= end($parts);
		$extension	= strtolower($extension);
		$name		= str_replace("." . $extension, "", $image);

		// Uploaded the image
		if (move_uploaded_file($temp_name, $uploaddir . $image))
		{
			// 1. Check to see if image size is 1024 by 200
			if (list($width, $height) = getimagesize($uploaddir . $image))
			{
				if ($width != $max_width && $height != $max_height)
					$errors[] = $txt['banner_error_1'];
			}
		else
		// 2. Check to see if the uploaded file is a image or not
		$errors[] = $txt['banner_error_2'];

		// 3. Check to see if file size is under the set max limit
		if ($_FILES['image']['size'] > $max_size)
			$errors[] = $txt['banner_error_3'];

		// 4. Check to see if the monthly file name is spelled correct
		$month = array(
			'New_Years',
			'Valentines',
			'St_Patricks',
			'Easter',
			'April_Fools',
			'Independence_Day',
			'Halloween',
			'Thanksgiving',
			'Christmas',
			'Today',
		);

		if (!in_array($name, $month))
			$errors[] = $txt['banner_error_4'];

		// 5. Check to see if the allowed image extension is correct
		if (!in_array($extension, $allowed_files))
			$errors[] = $txt['banner_error_5'];
		}
		else
		// 6. If the system is unable to upload image for any reason print Unable to upload file
		$errors[] = $txt['banner_error_6'];

		//Display errors and print Copy unsuccessful message, and remove image.
		if (!empty($errors))
		{
			$context['banner_errors'] = $errors;
			unlink($uploaddir . $image);
			$context['banner_error_general'] = $txt['banner_error_general'];
		}
		else
		{
			// Start of thumbnail creation
			$call = 'create'. ucfirst($extension);
			$call();

			//If no errors registered, print the success message
			redirectexit('action=admin;area=monthlybanners;sa=holiday_add');
		}
	}
}


// When remove_holiday_banners function is call it will remove the selected banner in the big dir and the small dir.


Function remove_holiday_banners()
{
	global $context, $txt, $settings, $uploaddir, $thumbnail_dir;

	// Remove chosen banner from big and small files
	if(isset($_GET['b']))
	{
		$inputted_banner = $_GET['b'];

		if(empty($_GET['b']))
		{
		fatal_lang_error('banner_file_check_error', false);
		}
	}

	if (!empty($inputted_banner))
	{
		unlink($uploaddir . $inputted_banner);
		unlink($thumbnail_dir . $inputted_banner);

		// Refresh the Page and Clear the Post Data
		redirectexit('action=admin;area=monthlybanners;sa=holiday_remove');
	}
}

// When createJpeg function is call it will create a thumbnail image of the banner and store it in the small dir


Function createJpeg()
{
	global $settings, $uploaddir, $thumbnail_dir, $newwidth, $newheight;

	$image = $_FILES['image']['name'];
	$uploadedfile = $uploaddir . $image;

	if(empty($image) or empty($_FILES))
		fatal_lang_error('banner_file_check_error', false);

	$src = imagecreatefromjpeg($uploadedfile);
	list($width, $height) = getimagesize($uploadedfile);
	$tmp = imagecreatetruecolor($newwidth, $newheight);
	imagecopyresampled($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	$filename = $thumbnail_dir . $image;
	imagejpeg($tmp, $filename, 100);
	imagedestroy($src);
	imagedestroy($tmp);
}


// When createJpg function is call it will create a thumbnail image of the banner and store it in the small dir


Function createJpg()
{
	global $settings, $uploaddir, $thumbnail_dir, $newwidth, $newheight;

	$image = $_FILES['image']['name'];
	$uploadedfile = $uploaddir . $image;

	if(empty($image) or empty($_FILES))
		fatal_lang_error('banner_file_check_error', false);

	$src = imagecreatefromjpeg($uploadedfile);
	list($width, $height) = getimagesize($uploadedfile);
	$tmp = imagecreatetruecolor($newwidth, $newheight);
	imagecopyresampled($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	$filename = $thumbnail_dir . $image;
	imagejpeg($tmp, $filename, 100);
	imagedestroy($src);
	imagedestroy($tmp);
}


// When createGif function is call it will create a thumbnail image of the banner and store it in the small dir


Function createGif()
{
	global $settings, $uploaddir, $thumbnail_dir, $newwidth, $newheight;

	$image = $_FILES['image']['name'];
	$uploadedfile = $uploaddir . $image;

	if(empty($image) or empty($_FILES))
		fatal_lang_error('banner_file_check_error', false);

	$src = imagecreatefromgif($uploadedfile);
	list($width, $height) = getimagesize($uploadedfile);
	$tmp = imagecreatetruecolor($newwidth, $newheight);
	imagecopyresampled($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	$filename = $thumbnail_dir . $image;
	imagegif($tmp, $filename);
	imagedestroy($src);
	imagedestroy($tmp);
}


// When createPng function is call it will create a thumbnail image of the banner and store it in the small dir


Function createPng()
{
	global $settings, $uploaddir, $thumbnail_dir, $newwidth, $newheight;

	$image = $_FILES['image']['name'];
	$uploadedfile = $uploaddir . $image;

	if(empty($image) or empty($_FILES))
		fatal_lang_error('banner_file_check_error', false);

	$src = imagecreatefrompng($uploadedfile);
	list($width, $height) = getimagesize($uploadedfile);
	$tmp = imagecreatetruecolor($newwidth, $newheight);
	imagecopyresampled($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
	$filename = $thumbnail_dir . $image;
	imagepng($tmp, $filename, 9);
	imagedestroy($src);
	imagedestroy($tmp);
}


// Holiday Settings


Function HolidaySettings($return_config = false)
{
	global $context, $sourcedir, $txt, $scripturl, $modSettings, $settings;
	require_once($sourcedir . '/ManageServer.php');

	// Note: The 'check' must come first or the text will not show up.
	$config_vars = array(
		array('check',	'holiday_settings_today'),'',
		array('check',	'holiday_settings_new_years'),'',
		array('check',	'holiday_settings_valentines'),'',
		array('check',	'holiday_settings_st_patricks'),'',
		array('check',	'holiday_settings_easter'),'',
		array('check',	'holiday_settings_april_fools'),'',
		array('check',	'holiday_settings_july_4th'),'',
		array('check',	'holiday_settings_halloween'),'',
		array('check',	'holiday_settings_thanksgiving'),'',
		array('check',	'holiday_settings_christmas'),
	);

	if ($return_config)
		return $config_vars;

	$context['sub_template'] = 'show_settings';

	$context['post_url'] = $scripturl . '?action=admin;area=monthlybanners;sa=HolidaySettings;save';
	$context['page_title'] = $txt['holiday_settings_title'];
	$context['settings_title'] = $txt['holiday_settings_title'];

	if (isset($_GET['save'])){
	
		checkSession();
		saveDBSettings($config_vars);
		redirectexit('action=admin;area=monthlybanners;sa=HolidaySettings');
	}

	prepareDBSettingContext($config_vars);
}


// The controller; doesn't do anything, just delegates.


function ManageBanners()
{
	global $context, $txt;

	// Format: 'sub-action' => array('function', 'permission')
	$subActions = array(
		'holiday_settings' => array('HolidaySettings', array('admin_forum', 'moderate_forum')),
		'banner_add' => array('BannerAdd', array('admin_forum', 'moderate_forum')),
		'banner_remove' => array('BannerRemove', array('admin_forum', 'moderate_forum')),
		'holiday_add' => array('HolidayAdd', array('admin_forum', 'moderate_forum')),
		'holiday_remove' => array('HolidayRemove', array('admin_forum', 'moderate_forum')),
	);

	// Default the sub-action to 'holiday_settings'.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'holiday_settings';

	// Have you got the proper permissions?
	isAllowedTo($subActions[$_REQUEST['sa']][1]);

	// Create the tabs for the template.
	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => $txt['banner_admin'],
		'description' => $txt['holiday_settings'],
		'tabs' => array(
			'holiday_settings' => array('description' => $txt['holiday_settings']),
			'banner_add' => array('description' => $txt['banner_add']),
			'banner_remove' => array('description' => $txt['banner_remove']),
			'holiday_add' => array('description' => $txt['holiday_add']),
			'holiday_remove' => array('description' => $txt['holiday_remove']),
		),
	);

	$subActions[$_REQUEST['sa']][0]();
}

// End of Script
